]> git.ipfire.org Git - thirdparty/git.git/blob - git-sh-setup.sh
Do not install shell libraries executable
[thirdparty/git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
7
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
13
14 git_broken_path_fix () {
15 case ":$PATH:" in
16 *:$1:*) : ok ;;
17 *)
18 PATH=$(
19 SANE_TOOL_PATH="$1"
20 IFS=: path= sep=
21 set x $PATH
22 shift
23 for elem
24 do
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
28 sep=:
29 SANE_TOOL_PATH=
30 esac
31 path="$path$sep$elem"
32 sep=:
33 done
34 echo "$path"
35 )
36 ;;
37 esac
38 }
39
40 # @@BROKEN_PATH_FIX@@
41
42 die() {
43 echo >&2 "$@"
44 exit 1
45 }
46
47 GIT_QUIET=
48
49 say () {
50 if test -z "$GIT_QUIET"
51 then
52 printf '%s\n' "$*"
53 fi
54 }
55
56 if test -n "$OPTIONS_SPEC"; then
57 usage() {
58 "$0" -h
59 exit 1
60 }
61
62 parseopt_extra=
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra="--keep-dashdash"
65
66 eval "$(
67 echo "$OPTIONS_SPEC" |
68 git rev-parse --parseopt $parseopt_extra -- "$@" ||
69 echo exit $?
70 )"
71 else
72 dashless=$(basename "$0" | sed -e 's/-/ /')
73 usage() {
74 die "Usage: $dashless $USAGE"
75 }
76
77 if [ -z "$LONG_USAGE" ]
78 then
79 LONG_USAGE="Usage: $dashless $USAGE"
80 else
81 LONG_USAGE="Usage: $dashless $USAGE
82
83 $LONG_USAGE"
84 fi
85
86 case "$1" in
87 -h|--h|--he|--hel|--help)
88 echo "$LONG_USAGE"
89 exit
90 esac
91 fi
92
93 set_reflog_action() {
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95 then
96 GIT_REFLOG_ACTION="$*"
97 export GIT_REFLOG_ACTION
98 fi
99 }
100
101 git_editor() {
102 if test -z "${GIT_EDITOR:+set}"
103 then
104 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
105 fi
106
107 eval "$GIT_EDITOR" '"$@"'
108 }
109
110 sane_grep () {
111 GREP_OPTIONS= LC_ALL=C grep "$@"
112 }
113
114 sane_egrep () {
115 GREP_OPTIONS= LC_ALL=C egrep "$@"
116 }
117
118 is_bare_repository () {
119 git rev-parse --is-bare-repository
120 }
121
122 cd_to_toplevel () {
123 cdup=$(git rev-parse --show-toplevel) &&
124 cd "$cdup" || {
125 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
126 exit 1
127 }
128 }
129
130 require_work_tree () {
131 test $(git rev-parse --is-inside-work-tree) = true ||
132 die "fatal: $0 cannot be used without a working tree."
133 }
134
135 get_author_ident_from_commit () {
136 pick_author_script='
137 /^author /{
138 s/'\''/'\''\\'\'\''/g
139 h
140 s/^author \([^<]*\) <[^>]*> .*$/\1/
141 s/'\''/'\''\'\'\''/g
142 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
143
144 g
145 s/^author [^<]* <\([^>]*\)> .*$/\1/
146 s/'\''/'\''\'\'\''/g
147 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
148
149 g
150 s/^author [^<]* <[^>]*> \(.*\)$/\1/
151 s/'\''/'\''\'\'\''/g
152 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
153
154 q
155 }
156 '
157 encoding=$(git config i18n.commitencoding || echo UTF-8)
158 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
159 LANG=C LC_ALL=C sed -ne "$pick_author_script"
160 }
161
162 # Make sure we are in a valid repository of a vintage we understand,
163 # if we require to be in a git repository.
164 if test -z "$NONGIT_OK"
165 then
166 GIT_DIR=$(git rev-parse --git-dir) || exit
167 if [ -z "$SUBDIRECTORY_OK" ]
168 then
169 test -z "$(git rev-parse --show-cdup)" || {
170 exit=$?
171 echo >&2 "You need to run this command from the toplevel of the working tree."
172 exit $exit
173 }
174 fi
175 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
176 echo >&2 "Unable to determine absolute path of git directory"
177 exit 1
178 }
179 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
180 fi
181
182 # Fix some commands on Windows
183 case $(uname -s) in
184 *MINGW*)
185 # Windows has its own (incompatible) sort and find
186 sort () {
187 /usr/bin/sort "$@"
188 }
189 find () {
190 /usr/bin/find "$@"
191 }
192 ;;
193 esac